import collections

def solve():
    n, m, k = map(int, input().split())
    adj = [[] for _ in range(n)]
    for _ in range(m):
        u, v = map(int, input().split())
        adj[u - 1].append(v - 1)
        adj[v - 1].append(u - 1)
    
    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p - 1, h))
    
    protected_warehouses = set()
    
    for guard_pos, guard_endurance in guards:
        q = collections.deque([(guard_pos, 0)])
        visited = [False] * n
        visited[guard_pos] = True
        
        while q:
            u, dist = q.popleft()
            if dist <= guard_endurance:
                protected_warehouses.add(u)
            
            for v in adj[u]:
                if not visited[v]:
                    visited[v] = True
                    q.append((v, dist + 1))
    
    sorted_protected = sorted(list(protected_warehouses))
    print(len(sorted_protected))
    if sorted_protected:
        print(*[x + 1 for x in sorted_protected])


solve() 
